% given a vector of m elements returns another vector of length m
% which has been calculated with a linear approximation of the 
% first derivative so that the filter has length equal to (2*orderFilter)+1
function d_vector = DerivateVector(vector, orderFilter)

cols = length(vector);

d_vector = vector;

%derivative filter: of the form [1 1 ... 1 0 -1 -1 ... -1]
v = [1*ones(1,orderFilter) 0 -1*ones(1,orderFilter)];

temp = conv(double(vector), v);

d_vector = temp(fix(length(v)/2)+1:length(temp)-fix(length(v)/2));


