%function C = CalculateCost_and_PathMatrices(emitted, received)
%
%  input:
%     emitted: j x 3 matrix where j is the length of the emitted sequence
%     of edges
%
%  returns:
%     C: length(received(1,:)) x length(emitted(1,:)) cost matrix
%     M: idem, but it is the matrix containing possible paths
%           1: indicates
%           2:
%           3:
function [C, M] = CalculateCost_and_PathMatrices(emitted, received)

C = (-99)*ones(length(received(:,1)), length(emitted(:,1)));
M = zeros(length(received(:,1)), length(emitted(:,1)));

for i=1:length(received(:,1)),        
    for j=1:length(emitted(:,1)),
        [C(i,j), M(i,j)] = Cost_and_Path(i,j,C,emitted,received);
    end
end
