%returns a n x 2 matrix where every row contains the index of an ellement
%of the projected sequence (j) which matches an ellement of the received
%sequence (i)
function matchings = TrackOptimalPath(C,M)


% M_bak = M;
% M = zeros(length(M_bak(:,1))+1, length(M_bak(1,:))+1);
% M(2:length(M(:,1)), 2:length(M(1,:))) = M_bak;
% M(1,:) = M(2,:);
% M(:,1) = M(:,2);

% %modified solution: we start in the vertex (max(j), max(i)) and we take the
% %path of maximum cost. If in any point the three possible paths have the
% %same cost, we consult the M matrix:
% 
% C_bak = C;
% C = zeros(length(C_bak(:,1))+1, length(C_bak(1,:))+1);
% C(2:length(C(:,1)), 2:length(C(1,:))) = C_bak;
% C(1,:) = C(2,:);
% C(:,1) = C(:,2);
% 
% matchings = [];
% while (i>1) & (j>1)
%     path = 0;    
%     if (C(i,j-1)==C(i-1,j-1)) & (C(i-1,j)==C(i-1,j-1))
%         path = M(i,j);
%     else
%         [mx, path] = max([C(i-1,j-1); C(i-1,j); C(i,j-1)]);
%     end
%    switch path  
%        case 1
%            matchings = [matchings; j-1 i-1];
%            i = i - 1;
%            j = j - 1;
%        case 2
%            i = i - 1;
%        case 3
%            j = j - 1;           
%    end    
% end


%index of the received sequence:
i = length(M(:,1));
%index of the emitted sequence:
j = length(M(1,:));


%solution paper COX et al.:
matchings = [];
while (i>0) & (j>0)
   switch M(i,j)   
       case 1
           matchings = [matchings; j i];
           i = i - 1;
           j = j - 1;
       case 2
           i = i - 1;
       case 3
           j = j - 1;           
   end
end